#!/bin/sh
# Program name: showmem
#	Shows shared memory segments and semaphores for each server
#
#	Note: This has two hard coded installation codes, L1 and L2
#
# Author: Paul Rodenhuis
#	  NSW Public Works
#	  paulr@pwd.nsw.gov.au
#
ipcs -mp |grep "^m"  | sort -1 +2 > /tmp/ipcs.out
ps -fu ingres | grep idbms | grep -v grep | sort -1 > /tmp/ingres_procs
if [ -f /tmp/csreport.out ]
then
rm /tmp/csreport.out
fi

for INSTALL in L1 L2
do
II_SYSTEM=/ingres/${INSTALL}; export II_SYSTEM
$II_SYSTEM/ingres/utility/csreport >> /tmp/csreport.out
done

# $2 is ID
echo  "ID	KEY        CPID  SOCKETID"
for i in `awk '{ print $2}' /tmp/ipcs.out`
do
set `grep  " $i " /tmp/ipcs.out |  cut -c 4-20,51-`
ID=$1
KEY=$2
#CPID = create PID LPID = last PID
CPID=$3
LPID=$4

if  grep $CPID /tmp/ingres_procs | egrep "L1|L2" > /dev/null
then
SOCKETID=`grep $CPID /tmp/csreport.out | awk '{print $7}'`
/usr/ucb/echo -n $ID"	"$KEY" "$CPID" "
/usr/ucb/echo -n $SOCKETID
grep  $CPID  /tmp/ingres_procs  | awk '{print $10}'
else
echo  $ID"	"$KEY" "$CPID
ps  -p $CPID | egrep -v "COMD|Menu|ms" 
fi
done
ipcs -sp | sort +2 -3
